use super::*;

pub enum Selected<'a, A: 'a, B: 'a, T: ?Sized + 'a + WeakFunctor> {
    A(A, T::F<'a, B>),
    B(T::F<'a, A>, B),
}

pub type SelectedWrapped<'a, A, B, T> = Wrap<'a, Selected<'a, A, B, T>, T>;

pub trait ApplicativeSelect: Functor {
    fn select<'a, A: 'a, B: 'a>(
        fa: Self::F<'a, A>,
        fb: Self::F<'a, B>,
    ) -> SelectedWrapped<'a, A, B, Self>
    where
        Self: 'a,
    {
        Self::fmap(|a| Selected::A(a, fb), fa)
    }
}

pub trait ApplicativeSelectExt<'a>: 'a + ApplicativeSelect {
    fn select_map<A: 'a, B: 'a, C: 'a>(
        f: impl 'a + FnOnce(Selected<'a, A, B, Self>) -> C,
        fa: Self::F<'a, A>,
        fb: Self::F<'a, B>,
    ) -> Self::F<'a, C> {
        Self::fmap(f, Self::select(fa, fb))
    }
}

impl<'a, T: 'a + ApplicativeSelect> ApplicativeSelectExt<'a> for T {}
